The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices.
— It is a matter of security to change such things every now and then, to keep the enemy in the dark.
— But look, I have chosen my number for good reasons. I am the Prime minister, you know!
— I know, so therefore your new number is also a prime. You will just have to paste four new digits over the four old ones on your office door.
— No, it’s not that simple. Suppose that I change the first digit to an , then the number will read 8033 which is not a prime!
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds.
— Correct! So I must invent a scheme for going from to by a path of prime numbers where only one digit is changed from one prime to the next prime.
Now, the minister of finance, who had been eavesdropping, intervened.
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to minimize the cost. You don’t know some very cheap software gurus, do you?
— In fact, I do. You see, there is this programming contest going on… Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is pounds. Note that the digit which got pasted over in step can not be reused in the last step – a new must be purchased.
Input
One line with a positive number: the number of test cases (at most ). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Examples
Input
3
1033 8179
1373 8017
1033 1033
Output
6
7
0
题意
给出两个四位的素数,要求每次只能变换一位,并且变换后的数字依旧是素数。
求经过多少步变换能够变成;如果无法变成,输出Impossible
思路
将的四位数字拆分了,每次变换一位,来判断是否符合条件,如果符合条件,将新数字加入队列,至到数字和相等,或队列为空
AC代码
#include <stdio.h>
#include <string.h>
#include <iostream>
#include <algorithm>
#include <math.h>
#include <limits.h>
#include <map>
#include <stack>
#include <queue>
#include <vector>
#include <set>
#include <string>
#include <time.h>
#define ll long long
#define ull unsigned long long
#define ms(a,b) memset(a,b,sizeof(a))
#define pi acos(-1.0)
#define INF 0x7f7f7f7f
#define lson o<<1
#define rson o<<1|1
#define bug cout<<"-------------"<<endl
#define debug(...) cerr<<"["<<#__VA_ARGS__":"<<(__VA_ARGS__)<<"]"<<"
"
const int maxn=1e4+10;
const int mod=1e9+7;
using namespace std;
int vis[maxn];
int _vis[maxn];
int cnt;
struct node
{
int num;
int step;
};
int bfs(int n,int m)
{
ms(_vis,0);
int newnum;
node p,q;
queue<node>que;
p.num=n;
p.step=0;
que.push(p);
_vis[n]=1;
while(!que.empty())
{
q=que.front();
que.pop();
if(q.num==m)
return q.step;
int get[4];
int N=q.num;
int _=0;
while(N)
{
get[_++]=N%10;
N/=10;
}
for(int i=0;i<4;i++)
{
int __=get[i];
for(int j=0;j<=9;j++)
{
if(get[i]!=j)
{
get[i]=j;
newnum=get[0]+get[1]*10+get[2]*100+get[3]*1000;
}
if(!vis[newnum]&&newnum>=1000&&newnum<10000&&!_vis[newnum])
{
p.num=newnum;
p.step=q.step+1;
_vis[newnum]=1;
que.push(p);
}
}
get[i]=__;
}
}
return -1;
}
void init()
{
vis[0]=vis[1]=1;
for(int i=2;i<maxn;i++)
{
if(!vis[i])
{
for(int j=2;j*i<maxn;j++)
vis[i*j]=1;
}
}
}
int main(int argc, char const *argv[])
{
ios::sync_with_stdio(false);
#ifndef ONLINE_JUDGE
freopen("in.txt", "r", stdin);
freopen("out.txt", "w", stdout);
double _begin_time = clock();
#endif
init();
int t;
cin>>t;
while(t--)
{
int n,m;
cin>>n>>m;
int ans=bfs(n,m);
if(ans==-1)
cout<<"Impossible"<<endl;
else
cout<<ans<<endl;
}
#ifndef ONLINE_JUDGE
long _end_time = clock();
printf("time = %lf ms.", _end_time - _begin_time);
#endif
return 0;
}